import gtk
import gtk.glade
import gobject

from assistant import PyAtCronAssistant

class PyAtCronMainwin:
	def __init__ (self):
		self.assistant = None

		self.widgetTree = gtk.glade.XML ("mainwin.glade", "mainwin")
		dic = {
						"on_mainwin_delete_event" : self.deleteEvent,
						"on_mainwin_destroy_event" : self.destroyEvent,
						"on_mainmenu_save_activate" : self.saveActivate,
						"on_mainmenu_quit_activate" : self.quitActivate,
						"on_mainmenu_new_activate" : self.newActivate,
						"on_mainmenu_properties_activate" : self.propertiesActivate,
						"on_mainmenu_delete_activate" : self.deleteActivate,
						"on_mainmenu_about_activate" : self.aboutActivate,
						"on_toolbar_new_clicked" : self.newClicked,
						"on_toolbar_properties_clicked" : self.propertiesClicked,
						"on_toolbar_delete_clicked" : self.deleteClicked,
						"on_tasklist_row_activated" : self.rowActivated
					}
		self.widgetTree.signal_autoconnect (dic)
		self.win = self.widgetTree.get_widget ("mainwin")

		self.updateTaskList ()

	def deleteEvent (self, event, obj):
		self.quit ()

	def destroyEvent (self, event, obj):
		self.quit ()

	def saveActivate (self, obj):
		self.save ()

	def quitActivate (self, obj):
		self.quit ()

	def newActivate (self, obj):
		self.createTask ()

	def propertiesActivate (self, obj):
		self.editTask ()

	def deleteActivate (self, obj):
		self.deleteTask ()

	def aboutActivate (self, obj):
		self.about ()

	def newClicked (self, obj):
		self.createTask ()

	def propertiesClicked (self, obj):
		self.editTask ()

	def deleteClicked (self, obj):
		self.deleteTask ()

	def rowActivated (self, obj, path, column):
		self.editTask ()

	def save (self):
		print "TODO: save"

	def quit (self):
		self.save ()
		gtk.main_quit ()

	def createTask (self):
		self.assistant = PyAtCronAssistant (self.win)

	def editTask (self):
		print "TODO: editTask"

	def deleteTask (self):
		print "TODO: deleteTask"

	def about (self):
		print "TODO: about"

	def updateTaskList (self):
		model = gtk.ListStore (gobject.TYPE_INT, gobject.TYPE_BOOLEAN, gobject.TYPE_STRING, gobject.TYPE_STRING)

		model.set (model.append (), 0, 0, 1, False, 2, "Save all my HOME folder", 3, "12/01/03 4:00 AM")
		model.set (model.append (), 0, 1, 1, True, 2, "Wake me up on the morning", 3, "11/12/03 7:00 AM")
		model.set (model.append (), 0, 2, 1, False, 2, "Start downloading CD1", 3, "11/12/03 8:00 AM")
		model.set (model.append (), 0, 3, 1, False, 2, "Start downloading CD2", 3, "11/12/03 11:00 AM")
		model.set (model.append (), 0, 4, 1, False, 2, "Start downloading CD3", 3, "11/12/03 2:00 PM")

		tasklist = self.widgetTree.get_widget ("tasklist")
		tasklist.set_model (model)

		textRenderer = gtk.CellRendererText ()
		textColumn = gtk.TreeViewColumn ("Name", textRenderer, text=2, strikethrough=1)
		tasklist.append_column(textColumn)

		textRenderer = gtk.CellRendererText ()
		textColumn = gtk.TreeViewColumn ("Next run time", textRenderer, text=3, strikethrough=1)
		tasklist.append_column(textColumn)
